; 
    include \masm32\include\masm32rt.inc
; 
    .data?
        hInst HINSTANCE ?
    .code
; 

DllMain proc hinstDLL:HINSTANCE, fdwReason:DWORD, lpvReserved:DWORD

    SWITCH fdwReason
        CASE DLL_PROCESS_ATTACH

            print "DLL_PROCESS_ATTACH",13,10

            ;--------------------------------------------------------
            ; The handle to the DLL module is passed in the hinstDLL
            ; parameter. For this DLL the handle is not needed, but
            ; for a DLL where code in the DLL does need the handle,
            ; this is a convenient place to get it and store it in
            ; the data section.
            ;--------------------------------------------------------

            push hinstDLL
            pop hInst

            mov eax, TRUE

        CASE DLL_PROCESS_DETACH

            print "DLL_PROCESS_DETACH",13,10
            inkey

        CASE DLL_THREAD_ATTACH

        CASE DLL_THREAD_DETACH

    ENDSW

    ret

DllMain endp

; 

SetClipboardText proc uses ebx edi lpszText:DWORD

    invoke OpenClipboard, NULL

    .IF eax

        invoke EmptyClipboard

        print ustr$(len(lpszText)),13,10

        ;-----------------------------------------------
        ; Allocate a global memory object for the text.
        ;-----------------------------------------------

        invoke GlobalAlloc, GMEM_MOVEABLE, len(lpszText)

        .IF eax

            mov ebx, eax

            print ustr$(ebx),13,10

            ;--------------------------------------
            ; Lock the global memory object to get
            ; a pointer to the object's memory.
            ;--------------------------------------

            invoke GlobalLock, ebx

            ;----------------------------------------------------
            ; The pointer to the memory cannot simply be left in
            ; EAX because the len macro used below will overwrite
            ; EAX, and this will cause MemCopy to fail.
            ;----------------------------------------------------

            mov edi, eax

            ;------------------------------
            ; Copy the text to the memory.
            ;------------------------------

            invoke MemCopy, lpszText, edi, len(lpszText)

            ;----------------------------------
            ; Unlock the global memory object.
            ;----------------------------------

            invoke GlobalUnlock, ebx

            ;----------------------------------
            ; Place the text on the clipboard.
            ;----------------------------------

            invoke SetClipboardData, CF_TEXT, ebx

            push eax
            print ustr$(eax),13,10
            pop eax

            ;---------------------------------------
            ; The system now owns the global memory
            ; object, so we must not free it.
            ;---------------------------------------

            .IF eax == 0

                print "SetClipboardData failed",13,10

            .ENDIF

        .ELSE

            print "GlobalAlloc failed",13,10

        .ENDIF

        invoke CloseClipboard

    .ELSE

        print "OpenClipboard failed",13,10

    .ENDIF

    ret

SetClipboardText endp

; 

end DllMain
